/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.cvut.felk.aos.openid;

import java.util.List;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.servlet.jsp.PageContext;
import org.openid4java.association.AssociationException;
import org.openid4java.consumer.ConsumerException;
import org.openid4java.consumer.ConsumerManager;
import org.openid4java.consumer.InMemoryConsumerAssociationStore;
import org.openid4java.consumer.InMemoryNonceVerifier;
import org.openid4java.consumer.VerificationResult;
import org.openid4java.discovery.DiscoveryException;
import org.openid4java.discovery.DiscoveryInformation;
import org.openid4java.message.AuthRequest;
import org.openid4java.message.MessageException;
import org.openid4java.message.ParameterList;
import org.openid4java.message.ax.FetchRequest;

/**
 *
 * @author lubos
 */
public class GoogleOpenIDHelper {
    
    String OPENID_MANAGER = "https://www.google.com/accounts/o8/id";
    String CALLBACK_URI = "http://localhost:8080/aos-openid/index.jsp";
    
    /**
     * Builds a login URL based on client ID, secret, callback URI, and scope
     */
    public AuthRequest getAuthReq(HttpSession session, 
                                  PageContext pageContext) 
            throws DiscoveryException, MessageException, ConsumerException {

    
        ConsumerManager manager=new ConsumerManager();
        pageContext.setAttribute("consumermanager", manager, PageContext.APPLICATION_SCOPE);
        manager.setAssociations(new InMemoryConsumerAssociationStore());
        manager.setNonceVerifier(new InMemoryNonceVerifier(5000));
      
        // perform discovery on the user-supplied identifier
        List discoveries = manager.discover(OPENID_MANAGER);

        // attempt to associate with an OpenID provider
        // and retrieve one service endpoint for authentication
        DiscoveryInformation discovered = manager.associate(discoveries);

        session.setAttribute("openid-disco", discovered);
         // obtain a AuthRequest message to be sent to the OpenID provider
        AuthRequest authReq = manager.authenticate(discovered, CALLBACK_URI);

        // Attribute Exchange example: fetching the 'email' attribute
        FetchRequest fetch = FetchRequest.createFetchRequest();
        fetch.addAttribute("email", "http://schema.openid.net/contact/email", true);
       
        // attach the extension to the authentication request
        authReq.addExtension(fetch);
        
        System.out.println("ok");
        return authReq;
    }
    
    public VerificationResult getVerificationResult(HttpServletRequest request, 
                                                    HttpSession session, 
                                                    PageContext pageContext) throws MessageException, DiscoveryException, AssociationException {
        
        System.out.println("ok2");
        ConsumerManager manager=(ConsumerManager) pageContext.getAttribute("consumermanager", PageContext.APPLICATION_SCOPE);
        ParameterList responselist = new ParameterList(request.getParameterMap());

        // retrieve the previously stored discovery information
        DiscoveryInformation discovered =
                    (DiscoveryInformation) session.getAttribute("openid-disco");

       // extract the receiving URL from the HTTP request
       StringBuffer receivingURL = request.getRequestURL();
       String queryString = request.getQueryString();
       if (queryString != null && queryString.length() > 0)
           receivingURL.append("?").append(request.getQueryString());

        // verify the response; ConsumerManager needs to be the same
        // (static) instance used to place the authentication request
       VerificationResult verification = manager.verify(
                receivingURL.toString(),
                responselist, discovered);
       return verification;
    }
    
    
}
